libdap::Error Class Reference

A class for error processing. More...

`#include <Error.h>`

Inheritance diagram for libdap::Error:

## Public Member Functions

| Error ()
| Error (const Error &copy_from) noexcept
| Error (ErrorCode ec, std::string msg, std::string file="", int line=0)
| Error (std::string msg, std::string file="", int line=0)
ErrorCode | get_error_code () const
std::string | get_error_message () const
std::string | get_file () const
int | get_line () const
bool | OK () const
| Is the Error object valid? More...
Error & | operator= (const Error &rhs)
bool | parse (FILE *fp)
| Parse an Error object. More...
void | print (FILE *out) const
void | print (std::ostream &out) const
void | set_error_code (ErrorCode ec=undefined_error)
void | set_error_message (std::string msg="")
void | set_file (std::string f)
void | set_line (int l)
const char * | what () const noexcept override
| The pointer is valid only for the lifetime of the Error instance. jhrg 9/22/20. More...

## Protected Attributes

ErrorCode | _error_code
std::string | _error_message
std::string | d_file
int | d_line {}

## Detailed Description

A class for error processing.

The Error class is used to transport error information from the server to the client within libdap. This class is also the base class for all the errors thrown by methods in the DAP, so catching Error will catch all DAP throws. Errors consist of an error code and a string. The code can be used to quickly distinguish between certain common errors while the string is used to convey information about the error to the user. The error code should never be displayed to the user.

This class is used on both clients and servers. The print() and parse() methods are used to send the object back and forth.

Note
  A past version of this class supported the notion of an error correcting program (Tcl, Java, ...) that could be sent from the server to the client to help users correct the error and resubmit the request. This never worked well in practice and that feature of the class is deprecated.

Author
  jhrg

Definition at line 93 of file Error.h.

## Constructor & Destructor Documentation

## Error() [1/3]

libdap::Error::Error | ( |  | ) |

inline

Specializations of Error should use this to set the error code and message.

Definition at line 103 of file Error.h.

## Error() [2/3]

libdap::Error::Error | ( | ErrorCode | ec,
|  | std::string | msg,
|  | std::string | file = `""`,
|  | int | line = `0`
| ) |  |

inline

Create an instance with a specific code and message string. This ctor provides a way to to use any code and string you'd like. The code can be one of the standard codes or it may be specific to your server. Thus a client which can tell it's dealing with a specific type of server can use the code accordingly. In general, clients simply show the error message to users or write it to a log file.

Parameters

  ec | The error code
  msg | The error message string.
  file | Name of the source file (optional)
  line | Line in the source file (optional)

Definition at line 117 of file Error.h.

## Error() [3/3]

libdap::Error::Error | ( | std::string | msg,
|  | std::string | file = `""`,
|  | int | line = `0`
| ) |  |

inline explicit

Create an instance with a specific message. The error code is set to `unknown_error`.

Parameters

  msg | The error message.
  file | Name of the source file (optional)
  line | Line in the source file (optional)

See also
  ErrorCode

Definition at line 129 of file Error.h.

## Member Function Documentation

## get_error_code()

ErrorCode libdap::Error::get_error_code | ( |  | ) | const

Get the ErrorCode for this instance.

Definition at line 214 of file Error.cc.

## get_error_message()

string libdap::Error::get_error_message | ( |  | ) | const

Return the current error message.

Definition at line 243 of file Error.cc.

## OK()

bool libdap::Error::OK | ( |  | ) | const

Is the Error object valid?

Use this function to determine whether an Error object is valid. To be a valid, an Error object must either be: 1) empty or contain a message and a code.

Returns
  TRUE if the object is valid, FALSE otherwise.

Definition at line 100 of file Error.cc.

## parse()

bool libdap::Error::parse | ( | FILE * | fp | ) |

Parse an Error object.

Given an input stream (FILE *) `fp`, parse an Error object from stream. Values for fields of the Error object are parsed and `this` is set accordingly. This is how a client program receives an error object from a server.

Parameters

  fp | A valid file pointer to an input stream.

Returns
  TRUE if no error was detected, FALSE otherwise.

Definition at line 123 of file Error.cc.

## print() [1/2]

void libdap::Error::print | ( | FILE * | out | ) | const

Creates a printable representation of the Error object. It is suitable for framing, and also for printing and sending over a network.

The printed representation produced by this function can be parsed by the parse() member function. Thus parse and print form a symmetrical pair that can be used to send and receive an Error object over the network in a MIME document.

Parameters

  out | A pointer to the output stream on which the Error object is to be rendered.

Definition at line 165 of file Error.cc.

## print() [2/2]

void libdap::Error::print | ( | std::ostream & | out | ) | const

Creates a printable representation of the Error object. It is suitable for framing, and also for printing and sending over a network.

The printed representation produced by this function can be parsed by the parse() member function. Thus parse and print form a symmetrical pair that can be used to send and receive an Error object over the network in a MIME document.

Parameters

  strm | A reference to the output stream on which the Error object is to be rendered.

Definition at line 194 of file Error.cc.

## set_error_code()

void libdap::Error::set_error_code | ( | ErrorCode | ec = `undefined_error` | ) |

Set the ErrorCode. If the current error message has not been set, use ec to set the error message. The resulting error message string is the same as the ErrorCode name. If ec is not within the range of values for an OPeNDAP ErrorCode, the error message is left unchanged.

Parameters

  ec | The new ErrorCode value.

Definition at line 227 of file Error.cc.

## set_error_message()

void libdap::Error::set_error_message | ( | std::string | msg = `""` | ) |

Set the error message.

Definition at line 252 of file Error.cc.

## what()

const char* libdap::Error::what | ( |  | ) | const

inline override noexcept

The pointer is valid only for the lifetime of the Error instance. jhrg 9/22/20.

Definition at line 156 of file Error.h.

The documentation for this class was generated from the following files:

- Error.h
- Error.cc